<template>
  <div id="app">
    <ContactList
      v-if="screenState === 'contactListScreen'"
      @go-to-add-contact-event="goToAddContactScreen"
      @delete-contac-tevent="refreshPageAfterDeleteContact"
      @see-contact-details-event="seeConatctDetails"
      @search-contact-event="searchContact"
      :listOfContact="contacts"
    />
    <ContactDetails
      v-if="screenState === 'contactDetailsScreen'"
      @go-to-edit-contact-screene-vent="editContact"
      @go-back-to-start-screen-even="cancelAction"
      @go-to-add-comment-screen-event="goToAddCommentScreen"
      @edit-comment-event="goToEditCommentScreen"
      @delet-comment-event="refreshPageAfterDeleteComment"
      :contact="contact"
      :comments="comments"
      :idContact="idContact"
    />
    <EditContact
      v-if="screenState === 'contactEditScreen'"
      :contact="contact"
      @save-contac-tevent="saveContactChanges"
      @go-back-to-contact-details-event="goBAckToLastScreen"
    />
    <EditComments
      v-if="screenState === 'contactEditScreen'"
      :contact="contact"
      @save-contac-tevent="saveCommentsChanges"
      @go-back-to-contact-details-event="goBAckToLastScreen"
    />
    <AddContact
      v-if="screenState === 'addContactScreen'"
      @save-contact-event="addNewContactToBD"
      @go-back-to-start-screen-event="cancelAction"
    />
    <AddComments
      v-if="screenState === 'AddCommentScreen'"
      @save-comment-event="addNewCommentToBD"
      @go-back-to-comment-details-screen-event="goBAckToLastScreen"
      :idContact="idContact"
    />
    <EditComment
      v-if="screenState === 'editCommentScreen'"
      :comment="comment"
      @save-comment-event="saveCommentChanges"
      @go-back-to-contact-details-event="goBAckToLastScreen"
    />
  </div>
</template>
<script>
import ContactDetails from "../src/components/ContactDetails.vue";
import ContactList from "./components/ContactList.vue";
import AddContact from "./components/AddContact.vue";
import EditContact from "./components/EditContact.vue";
import AddComments from "./components/AddComments.vue";
import EditComment from "./components/EditComment.vue";
import { v4 as uuidv4 } from "uuid";
export default {
  name: "App",
  components: {
    ContactList,
    AddContact,
    ContactDetails,
    EditContact,
    AddComments,
    EditComment
  },
  data() {
    return {
      contacts: null,
      contact: null,
      comments: null,
      comment: null,
      idContact: null,
      url: "/api/contact_list",
      urlComment: "/api/comments",
      urlSearchContact: "/api/search_contacts/",
      screenState: "contactListScreen"
    };
  },

  mounted: function() {
    this.onLoadingPage();
  },
  methods: {
    async apiSearchContact(searchedContact) {
      console.log("aqui link ", this.urlSearchContact + searchedContact);
      const result = await fetch(this.urlSearchContact + searchedContact);

      return await result.json();
    },

    async searchContact(searchedContact) {
      this.contacts = await this.apiSearchContact(searchedContact);
    },

    //////////////Funcionalidades Change Screen /////////////////
    editContact() {
      this.screenState = "contactEditScreen";
    },
    cancelAction() {
      this.screenState = "contactListScreen";
    },
    goToAddCommentScreen() {
      this.screenState = "AddCommentScreen";
    },
    goBAckToLastScreen() {
      this.screenState = "contactDetailsScreen";
    },
    goToAddContactScreen() {
      this.screenState = "addContactScreen";
    },
    //////////////Funcionalidades de componente ContactList /////////////////
    async refreshPageAfterDeleteContact(id) {
      await this.deleteContact(id);
      this.onLoadingPage();
    },
    async deleteContact(id) {
      await fetch(this.url + "/" + id, {
        method: "delete"
      }).then(response => response.json());
    },
    async onLoadingPage() {
      this.screenState = "contactListScreen";
      this.contacts = await this.loadContactList();
      this.comments = await this.loadContactComments();
      console.log(this.contacts);
    },

    async loadContactList() {
      const result = await fetch(this.url);
      return await result.json();
    },

    async loadContactDetails(id) {
      console.log(this.url + "/" + id);
      const result = await fetch(this.url + "/" + id);
      return await result.json();
    },
    async loadContactComments() {
      const result = await fetch(this.urlComment);
      return await result.json();
    },
    //////////////Funcionalidades de componente Contact Details /////////////////

    async goToEditCommentScreen(idcomment) {
      this.comment = await this.loadCommentById(idcomment);
      this.screenState = "editCommentScreen";
    },
    async loadCommentById(idcomment) {
      const result = await fetch(this.urlComment + "/" + idcomment);
      return await result.json();
    },
    async refreshPageAfterDeleteComment(idcomment) {
      await this.deletComment(idcomment);
      await this.seeConatctDetails(this.idContact);
      this.screenState = "contactDetailsScreen";
    },
    async deletComment(idcomment) {
      await fetch(this.urlComment + "/" + idcomment, {
        method: "delete"
      }).then(response => response.json());
    },
    async seeConatctDetails(id) {
      this.screenState = "contactDetailsScreen";
      this.contact = await this.loadContactDetails(id);
      this.idContact = id;
      this.comments = await this.loadContactComments(id);
      console.log(this.comments);
    },
    //////////////Funcionalidades de componente Edit Contact /////////////////
    async saveContactChanges(localContact) {
      await this.uploadLocalContact(localContact);
      this.onLoadingPage();
    },
    async uploadLocalContact(localContact) {
      await fetch(this.url + "/" + localContact.id, {
        method: "PUT",
        headers: {
          "Content-Type": "application/json"
        },
        body: JSON.stringify({
          id: localContact.id,
          name: localContact.name,
          familyName: localContact.familyName,
          mobile: localContact.mobile,
          email: localContact.email
        })
      }).then(response => response.json());
    },

    //////////////Funcionalidades de componente Add Contact /////////////////
    async addNewContactToBD(newContact) {
      await this.uploadNewContact(newContact);
      await this.onLoadingPage();
    },
    async uploadNewContact(newContact) {
      console.log(newContact);
      await fetch(this.url, {
        method: "POST",
        headers: {
          "Content-Type": "application/json"
        },
        body: JSON.stringify({
          id: uuidv4(),
          name: newContact.name,
          familyName: newContact.familyName,
          mobile: newContact.mobile,
          email: newContact.email
        })
      }).then(response => response.json());
    },
    //////////////Funcionalidades de componente  Add Comment/////////////////
    async addNewCommentToBD(newComment) {
      await this.uploadNewComment(newComment);
      await this.seeConatctDetails(this.idContact);
      this.screenState = "contactDetailsScreen";
    },
    async uploadNewComment(newComment) {
      console.log(newComment);
      await fetch(this.urlComment, {
        method: "POST",
        headers: {
          "Content-Type": "application/json"
        },
        body: JSON.stringify({
          id: uuidv4(),
          idContact: newComment.idContact,
          commentDate: newComment.commentDate,
          commentDetails: newComment.commentDetails
        })
      }).then(response => response.json());
    },
    async uploadLocalComment(localComment) {
      await fetch(this.urlComment + "/" + localComment.id, {
        method: "PUT",
        headers: {
          "Content-Type": "application/json"
        },
        body: JSON.stringify({
          id: localComment.id,
          idContact: localComment.idContact,
          commentDate: localComment.commentDate,
          commentDetails: localComment.commentDetails
        })
      }).then(response => response.json());
    },
    //////////////Funcionalidades de componente Edit Contact /////////////////
    async saveCommentChanges(localComment) {
      await this.uploadLocalComment(localComment);
      await this.seeConatctDetails(localComment.idContact);
    }
  }
};
</script>
<style>
#app {
  font-family: sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  margin: 0px;
}
body {
  margin: 0px;
  background: #e1ecf2;
  width: 100%;
  height: auto;
}
</style>
